/************************************************************************
 *   IRC - Internet Relay Chat, include/dnsbl.h
 *   Copyright (C) 2003 Dmitry Agaphonov
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* $Id: dnsbl.h,v 1.1.2.3 2003/03/22 08:12:41 rzhe Exp $ */

#if !defined(__DNSBL_H__)
#define __DNSBL_H__


typedef struct DNSBL aDNSBL;


extern aDNSBL	       *dnsbls;
extern Link	       *l_lines;

extern void rehash_dnsbls();
extern int  query_dnsbls(aClient *cptr, int mask);
extern int  check_blacklisted(aClient *cptr, aDNSBL *bl, struct hostent *hp,
		int flags);
extern void dnsbl_release(aDNSBL *bl);


#define ZONELEN			63

#define DNSBL_ACTIVE		0x0001
#define DNSBL_IP		0x0002
#define DNSBL_HOST		0x0004
#define DNSBL_LOCAL		0x0008
#define DNSBL_FILTER		0x0010

#define BLFLAGS_DOING		0x0001
#define BLFLAGS_GOTHOST		0x0002
#define BLFLAGS_SENTRHSS	0x0004
#define BLFLAGS_LISTEDLOCAL	DNSBL_LOCAL	/* must be the same bit */
#define BLFLAGS_LISTED		0x0010
#define BLFLAGS_EXCEPTED	0x0020
#define BLFLAGS_FOUND		(BLFLAGS_LISTED | BLFLAGS_EXCEPTED)

#define DoingDNSBL(x)		((x)->blflags & BLFLAGS_DOING)
#define SetDNSBL(x)		((x)->blflags |= BLFLAGS_DOING)
#define ClearDNSBL(x)		((x)->blflags &= ~BLFLAGS_DOING)


struct DNSBL
{
	char		zone[ZONELEN + 1];
	struct in_addr	exceptip;
	int		flags;

	int		clients;

	aDNSBL	       *next;
	aDNSBL	       *prev;
};


#endif /* !__DNSBL_H__ */
