#!/bin/sh

# $Id: version.c.SH,v 1.1.1.3.2.3 2002/12/27 00:50:28 rzhe Exp $

spitshell=cat
package=IRC

echo "Extracting $package/src/version.c..."

if test -r version.c.last
then
	generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c.last`
if test ! "$generation" ; then generation=0; fi
else
	generation=0
fi

generation=`expr $generation + 1`

uname=`uname -a`

SAVED_LC_ALL=$LC_ALL
LC_ALL=C
SAVED_LANG=$LANG
LANG=C
export LC_ALL LANG

creation=`date | \
awk '{if (NF == 6) \
{ print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
{ print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

LC_ALL=$SAVED_LC_ALL
LANG=$SAVED_LANG
export LC_ALL LANG

$spitshell >version.c <<!SUB!THIS!
/*
 *   IRC - Internet Relay Chat, src/version.c
 *   Copyright (C) 1990 Chelsea Ashley Dyerman
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * This file is generated by version.c.SH. Any changes made will go away.
 */

char *generation = "$generation";
char *creation = "$creation";
char version[128];

char *infotext[] =
    {
	 "$package --",
	 "Based on the original code written by Jarkko Oikarinen",
	 "Copyright 1988, 1989, 1990, 1991 University of Oulu, Computing Center",
	 "",
	 "This program is free software; you can redistribute it and/or",
	 "modify it under the terms of the GNU General Public License as",
	 "published by the Free Software Foundation; either version 1, or",
	 "(at your option) any later version.",
	 "",
	 "Send bug reports to bugs@ircd.ru",
	 "",
	 "The following people have contributed code, codepage data, or support",
	 "to the ircd-RU! project:",
	 "rzhe                Dmitry Agaphonov    rzhe@ircd.ru",
	 "kass                Alexander P.Kryloff kass@dsn.ru",
	 "Adami               Ruslan Vodopyanov   adami@bmtelecom.ru",
	 "raveman             Bob Ershov          raveman@wenet.ru",
	 "",
	 "We very appreciate help of other people who are not included in this",
	 "list.  Thanks also goes to all of you who helped us by issuing bug",
	 "reports, giving useful ideas and at least testing by using ircd-RU!.",
	 "We love you! :)",
	 "",
	 "The following people compose the bahamut team and actively",
	 "maintain the bahamut codebase:",
	 "lucas               Lucas Madar         lucas@negaverse.org",
	 "Epiphani            Aaron Wiebe         epiphani@dal.net",
	 "Raistlin_Majere     Jason Slagle        raistlin@bahamut.net",
	 "",
	 "The following people have contributed code, or support",
	 "to the bahamut team:",
	 "aClient             Diane Bruce         db@koruna.varner.com",
	 "Dakal               David Knepper       dakal@dal.net",
	 "Dalvenjah           Sven Nielsen        dalvenjah@dal.net",
	 "MSofty              Mark Salerno        msofty@dal.net",
	 "Rakarra             Ian Westcott        rakarra@dal.net",
	 "sedition            David Parton        sedition@dal.net",
	 "White_Dragon        Chip Norkus         wd@dal.net",
         "xPsycho             Ryan Smith          xpsycho@dal.net",
	 "srd                 Sean McKay          srd@dal.net",
	 "",
	 "The following people have contributed ideas or testing to the",
	 "bahamut project:",
	 "driz                David Friedman      driz@dal.net",
	 "habit               Melinda Thompson    habit@dal.net",
	 "Kevin               Kevin Turner        kevin@dal.net",
	 "drone               Mike Wilson         dalnetdrone@yahoo.com",
	 "",
	 "",
	 "Developers and Contributors for previous versions:",
	 "Chris A. Bongaarts  Chris Behrens       Diane Bruce",
	 "Johannes Erdfelt    Roger Espel Llima   Jon Lusky",
	 "Michael Pearce      Brian Kraemer       Joan Touzet",
	 "Chris Portman       Keith Fralick       Sam Noble",
	 "Taner Halicioglu    Chris Behrens       Darren Reed",
	 "Markku Savela       Greg Lindahl        Jarkko Oikarinen",
	 "Armin Gruner        Matthew Green       Chuck Kane",
	 "Matt Lyle           Vesa Ruokonen       Nicolas PIOCH",
	 "Stellan Klebom      Dan Goodwin         Mike Bolotski",
	 "Ian Frechette       Markku Jarvinen     Kimmo Suominen",
	 "Jeff Trim           Vijay Subramaniam   Karl Kleinpaste",
	 "Bill Wisner         Tom Davis           Hugo Calendar",
	 "Tom Hopkins         Stephen van den Berg",
	 "Bo Adler            Michael Sandrof     Jon Solomon",
	 "Jan Peterson        Helen Rose          Paul Graham",
	 "",
	 "Thanks also goes to those persons not mentioned here who have added",
	 "their advice, opinions, and code to IRC.",
	 "Thanks also to those who provide the kind sys admins who let me and",
	 "others continue to develop IRC.",
	 "",
	 0,
};
!SUB!THIS!
